/* Name.h provides the Name class.
 * ... other documentation omitted ...
 ***************************************************************/

#include <string>            // class string
#include <sstream>           //istringstream, ostringstream
using namespace std;

class Name
{
 public:
   // ... other constructors omitted ...
   Name(string fullName);

   string asString() const;
   
   string getFirstName() const;
   string getMiddleName() const;
   string getLastName() const;
   
   void print(ostream& out) const;
   // ... other methods omitted ...

 private:
   string myFirstName, myMiddleName, myLastName;
};

      
inline Name::Name(string fullName)
{
   istringstream ssin(fullName);
      ssin >> myFirstName >> myMiddleName >> myLastName;
}

inline string Name::asString() const
{
  return myFirstName + ' ' + myMiddleName + ' ' + myLastName;
}

/* alternative definition using an ostringstream
inline string Name::asString() const
{
   ostringstream ssout;
   ssout << myFirstName << ' ' << myMiddleName << ' ' << myLastName;
   return ssout.str();
}
*/

inline string Name::getFirstName() const
{
   return myFirstName;
}

inline string Name::getMiddleName() const
{
   return myMiddleName;
}

inline string Name::getLastName() const
{
   return myLastName;
}

inline void Name::print(ostream& out) const
{
  out << myFirstName << ' ' << myMiddleName << ' ' << myLastName;
}
